curl --request POST \
--url https://api.example.com/api/v1/allocations/{id}/assign/ \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"device_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"rack_names": [
"<string>"
],
"device_role_slugs": [
"<string>"
],
"all_devices": false,
"dry_run": false
}
'import requests
url = "https://api.example.com/api/v1/allocations/{id}/assign/"
payload = {
"device_ids": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"rack_names": ["<string>"],
"device_role_slugs": ["<string>"],
"all_devices": False,
"dry_run": False
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
device_ids: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
rack_names: ['<string>'],
device_role_slugs: ['<string>'],
all_devices: false,
dry_run: false
})
};
fetch('https://api.example.com/api/v1/allocations/{id}/assign/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/api/v1/allocations/{id}/assign/",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'device_ids' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'rack_names' => [
'<string>'
],
'device_role_slugs' => [
'<string>'
],
'all_devices' => false,
'dry_run' => false
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/api/v1/allocations/{id}/assign/"
payload := strings.NewReader("{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/api/v1/allocations/{id}/assign/")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/api/v1/allocations/{id}/assign/")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}"
response = http.request(request)
puts response.read_body{
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"dry_run": true,
"matched_device_count": 123,
"filtered_out_device_count": 123,
"assigned_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"already_member_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"conflicts": [
{
"device_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"device_name": "<string>",
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"tenant_name": "<string>"
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"dry_run": true,
"matched_device_count": 123,
"filtered_out_device_count": 123,
"assigned_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"already_member_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"conflicts": [
{
"device_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"device_name": "<string>",
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"tenant_name": "<string>"
}
]
}Assign devices to allocation
Assign devices selected by UUID, rack name, or an explicit all_devices flag. Non-conflicting devices are still assigned when overlaps are found; those partial-success responses use HTTP 409 and include every conflict. Dry runs with conflicts also return 409 without assigning anything.
curl --request POST \
--url https://api.example.com/api/v1/allocations/{id}/assign/ \
--header 'Authorization: Bearer <token>' \
--header 'Content-Type: application/json' \
--data '
{
"device_ids": [
"3c90c3cc-0d44-4b50-8888-8dd25736052a"
],
"rack_names": [
"<string>"
],
"device_role_slugs": [
"<string>"
],
"all_devices": false,
"dry_run": false
}
'import requests
url = "https://api.example.com/api/v1/allocations/{id}/assign/"
payload = {
"device_ids": ["3c90c3cc-0d44-4b50-8888-8dd25736052a"],
"rack_names": ["<string>"],
"device_role_slugs": ["<string>"],
"all_devices": False,
"dry_run": False
}
headers = {
"Authorization": "Bearer <token>",
"Content-Type": "application/json"
}
response = requests.post(url, json=payload, headers=headers)
print(response.text)const options = {
method: 'POST',
headers: {Authorization: 'Bearer <token>', 'Content-Type': 'application/json'},
body: JSON.stringify({
device_ids: ['3c90c3cc-0d44-4b50-8888-8dd25736052a'],
rack_names: ['<string>'],
device_role_slugs: ['<string>'],
all_devices: false,
dry_run: false
})
};
fetch('https://api.example.com/api/v1/allocations/{id}/assign/', options)
.then(res => res.json())
.then(res => console.log(res))
.catch(err => console.error(err));<?php
$curl = curl_init();
curl_setopt_array($curl, [
CURLOPT_URL => "https://api.example.com/api/v1/allocations/{id}/assign/",
CURLOPT_RETURNTRANSFER => true,
CURLOPT_ENCODING => "",
CURLOPT_MAXREDIRS => 10,
CURLOPT_TIMEOUT => 30,
CURLOPT_HTTP_VERSION => CURL_HTTP_VERSION_1_1,
CURLOPT_CUSTOMREQUEST => "POST",
CURLOPT_POSTFIELDS => json_encode([
'device_ids' => [
'3c90c3cc-0d44-4b50-8888-8dd25736052a'
],
'rack_names' => [
'<string>'
],
'device_role_slugs' => [
'<string>'
],
'all_devices' => false,
'dry_run' => false
]),
CURLOPT_HTTPHEADER => [
"Authorization: Bearer <token>",
"Content-Type: application/json"
],
]);
$response = curl_exec($curl);
$err = curl_error($curl);
curl_close($curl);
if ($err) {
echo "cURL Error #:" . $err;
} else {
echo $response;
}package main
import (
"fmt"
"strings"
"net/http"
"io"
)
func main() {
url := "https://api.example.com/api/v1/allocations/{id}/assign/"
payload := strings.NewReader("{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}")
req, _ := http.NewRequest("POST", url, payload)
req.Header.Add("Authorization", "Bearer <token>")
req.Header.Add("Content-Type", "application/json")
res, _ := http.DefaultClient.Do(req)
defer res.Body.Close()
body, _ := io.ReadAll(res.Body)
fmt.Println(string(body))
}HttpResponse<String> response = Unirest.post("https://api.example.com/api/v1/allocations/{id}/assign/")
.header("Authorization", "Bearer <token>")
.header("Content-Type", "application/json")
.body("{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}")
.asString();require 'uri'
require 'net/http'
url = URI("https://api.example.com/api/v1/allocations/{id}/assign/")
http = Net::HTTP.new(url.host, url.port)
http.use_ssl = true
request = Net::HTTP::Post.new(url)
request["Authorization"] = 'Bearer <token>'
request["Content-Type"] = 'application/json'
request.body = "{\n \"device_ids\": [\n \"3c90c3cc-0d44-4b50-8888-8dd25736052a\"\n ],\n \"rack_names\": [\n \"<string>\"\n ],\n \"device_role_slugs\": [\n \"<string>\"\n ],\n \"all_devices\": false,\n \"dry_run\": false\n}"
response = http.request(request)
puts response.read_body{
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"dry_run": true,
"matched_device_count": 123,
"filtered_out_device_count": 123,
"assigned_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"already_member_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"conflicts": [
{
"device_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"device_name": "<string>",
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"tenant_name": "<string>"
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"detail": "<string>",
"code": "error",
"field_errors": [
{
"field": "<string>",
"messages": [
"<string>"
]
}
]
}{
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"dry_run": true,
"matched_device_count": 123,
"filtered_out_device_count": 123,
"assigned_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"already_member_devices": [
{
"id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"name": "<string>"
}
],
"conflicts": [
{
"device_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"device_name": "<string>",
"allocation_id": "3c90c3cc-0d44-4b50-8888-8dd25736052a",
"tenant_name": "<string>"
}
]
}Authorizations
The access token received from the authorization server in the OAuth 2.0 flow.
Path Parameters
A UUID string identifying this allocation.
Body
Selectors for assigning a device cohort to an existing allocation.
Device UUIDs to select. Mutually exclusive with rack_names.
1 - 2000 elementsRack names in the allocation's site whose devices should be selected.
1 - 100 elements1Optional device-role slugs applied after the device or rack selector.
1 - 100 elements1Explicitly select every device in the allocation's site. Required when device_ids and rack_names are both omitted.
Return the planned outcome without changing allocation memberships.
Response
Typed result for a live allocation assignment or dry run.
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes
Show child attributes